; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *


    h2dword PROTO :DWORD
    H2dw    PROTO :DWORD

    .data
      align 16
      tbl1 \
        db 00h,10h,20h,30h,40h,50h,60h,70h,80h,90h,0,0,0,0,0,0      ; 63
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h,0,0,0,0,0,0,0,0,0      ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h

      tbl2 \
        db 00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0,0,0,0,0,0      ; 63
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh,0,0,0,0,0,0,0,0,0            ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh

      ; sub 48 from both tables

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    push esi

    invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

    REPEAT 4

    invoke GetTickCount
    push eax

    mov esi, 10000000

  align 16
  @@:
    fn H2dw,"A1B2C3D4"
    fn H2dw,"4D3C2B1A"
    fn H2dw,"12345678"
    fn H2dw,"87654321"
    fn H2dw,"ABCDEF12"
    fn H2dw,"09ABCDEF"
    fn H2dw,"21FEDCBA"
    fn H2dw,"FEDCBA90"
    fn H2dw,"10293847"
    fn H2dw,"12345678"
    sub esi, 1
    jnz @B

    print hex$(eax),13,10

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," lingo",13,10

    invoke SleepEx,100,0

    invoke GetTickCount
    push eax

    mov esi, 10000000

  align 16
  @@:
    fn h2dword,"A1B2C3D4"
    fn h2dword,"4D3C2B1A"
    fn h2dword,"74839201"
    fn h2dword,"87654321"
    fn h2dword,"ABCDEF12"
    fn h2dword,"09ABCDEF"
    fn h2dword,"21FEDCBA"
    fn h2dword,"FEDCBA90"
    fn h2dword,"10293847"
    fn h2dword,"12345678"
    sub esi, 1
    jnz @B

    print hex$(eax),13,10

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," hutch",13,10

    invoke SleepEx,100,0

    ENDM

    invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop esi

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

h2dword proc phex:DWORD

    mov edx, [esp+4]
    mov [esp-4], ebx

    xor eax, eax

    movzx ecx, BYTE PTR [edx]
    movzx ebx, BYTE PTR [edx+1]
    mov ah, [ecx+tbl1-48]
    add ah, [ebx+tbl2-48]

    movzx ecx, BYTE PTR [edx+2]
    movzx ebx, BYTE PTR [edx+3]
    mov al, [ecx+tbl1-48]
    add al, [ebx+tbl2-48]

    rol eax, 16

    movzx ecx, BYTE PTR [edx+4]
    movzx ebx, BYTE PTR [edx+5]
    mov ah, [ecx+tbl1-48]
    add ah, [ebx+tbl2-48]

    movzx ecx, BYTE PTR [edx+6]
    movzx ebx, BYTE PTR [edx+7]
    mov al, [ecx+tbl1-48]
    add al, [ebx+tbl2-48]

    mov ebx, [esp-4]

    ret 4

h2dword endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:none
OPTION EPILOGUE:none
comment * Hex2Dword by lingo *
Align 16
H2dw	proc		lHexValue:dword
			mov	eax, [esp+4]	; eax->buffer with string
			mov	[esp+4], ebx	
			mov	ecx, [eax]
			mov	ebx, [eax+4]

			movzx	eax, cl
			movzx edx, word ptr [tbl1+eax-48-1]
			mov	al, ch
			bswap ecx
			add	dh, [tbl2+eax-48]

			mov	al, cl
			mov	dl, [tbl2+eax-48]
			mov	al, ch
			add	dl, [tbl1+eax-48]

			movzx	ecx, bl
			movzx	eax, word ptr [tbl1+ecx-48-1]
			mov	cl, bh
			bswap ebx
			add	ah, [tbl2+ecx-48]

			mov	cl, bl
			mov	al, [tbl2+ecx-48]
			mov	cl, bh
			add	al, [tbl1+ecx-48]

			shl	edx, 16
			mov	ebx,[esp+4]
			add	eax, edx
			ret	4
H2dw	endp
OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; 

end start






















